clear;
close all;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Exercise 5:

f = double(imread('coins.png'));

f1 = blur(f,1);
f2 = blur(f,2.5);
f3 = blur(f,5);

figure;

% show blurred images
subplot(3,4,1);
imshow(uint8(f));

subplot(3,4,2);
imshow(uint8(f1));

subplot(3,4,3);
imshow(uint8(f2));

subplot(3,4,4);
imshow(uint8(f3));

% show gradients at original scale
subplot(3,4,5);
imshow(uint8(absgrad(f)));

subplot(3,4,6);
imshow(uint8(absgrad(f1)));

subplot(3,4,7);
imshow(uint8(absgrad(f2)));

subplot(3,4,8);
imshow(uint8(absgrad(f3)));

% show gradients rescaled
subplot(3,4,9);
imshow(absgrad(f), []);

subplot(3,4,10);
imshow(absgrad(f1), []);

subplot(3,4,11);
imshow(absgrad(f2), []);

subplot(3,4,12);
imshow(absgrad(f3), []);



function g = absgrad(f)
    dxg = dx(f);
    dyg = dy(f);
    g = sqrt(dxg.^2 + dyg.^2);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% derivatives from exercise 3:
function d = dx(f)
    d = f(:,[2:end end]) - f;
end

function d = dy(f)
    d = f([2:end end],:) - f;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Gaussian blurring from exercise 4:
function g = blur(f, sigma)

    % radius of the truncated kernel
    r = ceil(3*sigma);

    % meshgrid coordinates such that 0 is in the matrix center
    x = -r:1:r;
    [X,Y] = meshgrid(x);
    
    % compute kernel elements
    w = exp( -(X.^2+Y.^2)/(2*sigma^2) );
    
    % normalize the kernel to sum up to 1
    w = w / sum(w(:));
    
    % convolve image with kernel
    g = conv2(f, w, 'same');
end